#include <string.h>
#include <stdio.h>
#include <windows.h>

#define DISKBUF	(0x00010000)
#define VRAM	(0x000a0000)

#define XSIZE 640
#define YSIZE 480

struct REGS {
	unsigned int ip;
	unsigned int regs[256];
	unsigned int sp;
	unsigned short flags;
};

/* col.cpp */
BITMAPINFO* getBmi(void);
unsigned char* getBmpData(void);
void init_vram(unsigned char *mem);
void reflesh_vram(unsigned char *mem);

/* run.cpp */
void init_regs(struct REGS *regs);
int init_disk(unsigned char *mem, char *filename);
void run_bin(struct REGS *regs, unsigned char *mem);

/* ȉ@B錾 */

#define IP			(0x80)
#define REGS_BASE	(0x81)

#define MOV_MEM		(0x40)
#define MOV_REG		(0x41)
#define MOV_ETC		(0x42)

#define NOP			(0x00)
#define MOV			(0x01)
#define CALL		(0x02)
#define RET			(0x03)
#define JMP			(0x04)
#define PUSH		(0x05)
#define POP			(0x06)
#define INT			(0x07)
#define CLI			(0x08)
#define STI			(0x09)
#define ADD			(0x0a)
#define SUB			(0x0b)
#define OR			(0x0c)
#define XOR			(0x0d)
#define AND			(0x0e)
#define CMP			(0x0f)
#define IDIV		(0x10)
#define IMUL		(0x11)

/* ȉ\̐錾 */

struct IP_MOV {
	unsigned char bincode;
	unsigned char mrflug00;
	unsigned char mrflug01;
	unsigned int data0;
	unsigned char mrflug10;
	unsigned char mrflug11;
	unsigned int data1;
};

struct IP_CALL {
	unsigned char bincode;
	unsigned char mrflug0;
	unsigned char mrflug1;
	unsigned int addr;
};

struct IP_RET {
	unsigned char bincode;
};

struct IP_JMP {
	unsigned char bincode;
	unsigned char mrflug0;
	unsigned char mrflug1;
	unsigned int addr;
};

struct IP_PUSH {
	unsigned char bincode;
	unsigned char mrflug0;
	unsigned char mrflug1;
	unsigned int data;
};

struct IP_POP {
	unsigned char bincode;
	unsigned char mrflug0;
	unsigned char mrflug1;
	unsigned int data;
};

struct IP_CLI {
	unsigned char bincode;
};

struct IP_STI {
	unsigned char bincode;
};

struct IP_ADD {
	unsigned char bincode;
	unsigned char mrflug00;
	unsigned char mrflug01;
	unsigned int data0;
	unsigned char mrflug10;
	unsigned char mrflug11;
	unsigned int data1;
};

struct IP_SUB {
	unsigned char bincode;
	unsigned char mrflug00;
	unsigned char mrflug01;
	unsigned int data0;
	unsigned char mrflug10;
	unsigned char mrflug11;
	unsigned int data1;
};

struct IP_OR {
	unsigned char bincode;
	unsigned char mrflug00;
	unsigned char mrflug01;
	unsigned int data0;
	unsigned char mrflug10;
	unsigned char mrflug11;
	unsigned int data1;
};

struct IP_XOR {
	unsigned char bincode;
	unsigned char mrflug00;
	unsigned char mrflug01;
	unsigned int data0;
	unsigned char mrflug10;
	unsigned char mrflug11;
	unsigned int data1;
};

struct IP_AND {
	unsigned char bincode;
	unsigned char mrflug00;
	unsigned char mrflug01;
	unsigned int data0;
	unsigned char mrflug10;
	unsigned char mrflug11;
	unsigned int data1;
};
