#include "DSC-100.h"

static unsigned char table_rgb[16 * 3] = {
	0x00, 0x00, 0x00,
	0xff, 0x00, 0x00,
	0x00, 0xff, 0x00,
	0xff, 0xff, 0x00,
	0x00, 0x00, 0xff,
	0xff, 0x00, 0xff,
	0x00, 0xff, 0xff,
	0xff, 0xff, 0xff,
	0xc6, 0xc6, 0xc6,
	0x84, 0x00, 0x00,
	0x00, 0x84, 0x00,
	0x84, 0x84, 0x00,
	0x00, 0x00, 0x84,
	0x84, 0x00, 0x84,
	0x3a, 0x6e, 0xa5,
	0x84, 0x84, 0x84
};

struct my_BITMAPINFO {
	BITMAPINFOHEADER header;
	RGBQUAD color_table[16];
};

static const int lineSize=(XSIZE+3)&(~3); // 4̔{̃TCYɃACg
static my_BITMAPINFO bmi;
static unsigned char bmpData[YSIZE*lineSize];

BITMAPINFO* getBmi(void) {
	return (BITMAPINFO*)&bmi;
}

unsigned char* getBmpData(void) {
	return bmpData;
}

void init_vram(unsigned char *mem)
{
	int x, y;
	int i;

	bmi.header.biSize=sizeof(bmi.header);
	bmi.header.biWidth=XSIZE;
	bmi.header.biHeight=-YSIZE;
	bmi.header.biPlanes=1;
	bmi.header.biBitCount=8;
	bmi.header.biCompression=0;
	bmi.header.biSizeImage=sizeof(bmpData);
	bmi.header.biXPelsPerMeter=0;
	bmi.header.biYPelsPerMeter=0;
	bmi.header.biClrUsed=16;
	bmi.header.biClrImportant=0;

	for(i = 0; i < 16; i++) {
		bmi.color_table[i].rgbRed=table_rgb[i * 3 + 0];
		bmi.color_table[i].rgbGreen=table_rgb[i * 3 + 1];
		bmi.color_table[i].rgbBlue=table_rgb[i * 3 + 2];
	}

	for(y = 0; y < YSIZE; y++) {
		for(x = 0; x < XSIZE; x++) {
			mem[VRAM + (y * XSIZE + x)] = 0;
		}
	}
}

void reflesh_vram(unsigned char *mem)
{
	int x, y;

	for(y = 0; y < YSIZE; y++) {
		for(x = 0; x < XSIZE; x++) {
			unsigned char nowMem=mem[VRAM + (y * XSIZE + x)];
			if(nowMem != 0 && nowMem>=0 && nowMem<16) {
				bmpData[y*lineSize+x]=nowMem;
			} else {
				bmpData[y*lineSize+x]=0;
			}
		}
	}
}
